function GameModeGen::getEnabledAddons(%this)
{
	%filepath = findFirstFile("Add-Ons/*_*/server.cs");
	while(strLen(%filepath) > 0)
	{
		%zip = getSubStr(%filepath,8,strLen(%filepath)-strLen("/server.cs")-strLen("Add-Ons/"));
		if($AddOn__[%zip] $= 1)
		{
			%list = %list TAB %zip;
		}
		%filepath = findNextFile("Add-Ons/*_*/server.cs");
	}
	return trim(%list);
}
function GameModeGen::getEnvironment(%this)
{
	saveEnvironment("config/tempenv.txt");
	%file = new FileObject();
	%file.openForRead("config/tempenv.txt");
	while(!%file.isEOF())
	{
		if(%str $= "")
			%str = %file.readLine();
		else
			%str = %str NL %file.readLine();
	}
	%file.close();
	%file.delete();
	fileDelete("config/tempenv.txt");
	return %str;
}
function GameModeGen::getSave(%this)
{
	Gen_ServerSave("config/gamemode/GameMode_" @ %this.name @ "/save.bls");
}
function GameModeGen::onAdd(%this)
{
	if(%this.name $= "")
	{
		error("Please make a GameModeGen with a name!");
		%this.delete();
		return;
	}
	if(isFile("config/gamemode/GameMode_" @ %this.name @ "/gamemode.txt"))
	{
		error(%this.name @ " is already in use.");
		%this.delete();
		return;
	}
	if(getWordCount(%name) > 1)
	{
		error("The name of the gamemode must be only 1 word!");
		%this.delete();
		return;
	}
	if(%this.description $= "")
	{
		error("Please add a description field!");
		%this.delete();
		return;
	}
	%path = "config/gamemode/GameMode_" @ %this.name @ "/";
	%file = new FileObject();
	%file.openForWrite(%path @ "gamemode.txt");
	%addons = %this.getEnabledAddOns();
	%file.writeLine("ADDON Support_Player_Persistence");
	for(%i=0;%i<getFieldCount(%addons);%i++)
	{
		%field = getField(%addons,%i);
		%file.writeLine("ADDON " @ trim(%field));
	}
	if(isFile(%this.scriptFile))
	{
		%file.writeLine("ADDON GameMode_" @ %this.name);
	}
	%file.writeLine("");
	%file.writeLine("//environment");
	%env = %this.getEnvironment();
	for(%i=0;%i<getLineCount(%env);%i++)
	{
		%line = getLine(%env,%i);
		%file.writeLine(%line);
	}
	%file.writeLine("");
	%file.writeLine("//minigame rules");
	if(isObject(%this.minigame))
	{
		%m = %this.minigame;
		%file.writeLine("$MiniGame::Enabled 1");
		%file.writeLine("$MiniGame::GameColor " @ %m.colorIdx);
		%file.writeLine("$MiniGame::InviteOnly " @ %m.inviteOnly);
		%file.writeLine("$MiniGame::IncludeAllPlayersBricks " @ %m.UseAllPlayersBricks);
		%file.writeLine("$MiniGame::PlayersUseOwnBricks " @ %m.PlayersUseOwnBricks);
		%file.writeLine("");
		%file.writeline("$MiniGame::Points_BreakBrick " @ %m.Points_BreakBrick);
		%file.writeLine("$MiniGame::Points_PlantBrick " @ %m.Points_PlantBrick);
		%file.writeLine("$MiniGame::Points_KillPlayer " @ %m.Points_KillPlayer);
		%file.writeLine("$MiniGame::Points_KillSelf " @ %m.Points_KillSelf);
		%file.writeLine("");
		%file.writeLine("$MiniGame::RespawnTime " @ %m.RespawnTime);
		%file.writeline("$MiniGame::VehicleRespawnTime " @ %m.VehicleRespawnTime);
		%file.writeLine("$MiniGame::BrickRespawnTime " @ %m.BrickRespawnTime);
		%file.writeLine("");
		%file.writeLine("$MiniGame::UseSpawnBricks " @ %m.UseSpawnBricks);
		%file.writeLine("$MiniGame::FallingDamage " @ %m.FallingDamage);
		%file.writeLine("$MiniGame::WeaponDamage " @ %m.WeaponDamage);
		%file.writeLine("$MiniGame::SelfDamage " @ %m.SelfDamage);
		%file.writeLine("$MiniGame::VehicleDamage " @ %m.VehicleDamage);
		%file.writeLine("$MiniGame::BrickDamage " @ %m.BrickDamage);
		%file.writeLine("$MiniGame::EnableWand " @ %m.EnableWand);
		%file.writeLine("$Minigame::EnableBuilding " @ %m.EnableBuilding);
		%file.writeLine("$MiniGame::EnablePainting " @ %m.EnablePainting);
		%file.writeLine("");
		%file.writeLine("$MiniGame::PlayerDataBlockName " @ %m.PlayerDataBlock.uiName);
		%file.writeLine("");
		for(%i=0;%i<5;%i++)
		{
			eval("%v = %m.StartEquip" @ %i @ ".uiName;");
			%file.writeLine("$MiniGame::StartEquipName" @ %i @ " " @ %v);
		}
	}
	else
	{
		%file.writeLine("$MiniGame::Enabled 0");
	}
	%file.writeLine("");
	%file.writeLine("$Server::WelcomeMessage " @ $pref::server::WelcomeMessage);
	%file.writeLine("");
	%file.close();
	%file.delete();

	%this.getSave();
	%path = "config/gamemode/GameMode_" @ %this.name @ "/"; //incase someone forgot/redefined somewhere!
	fileCopy("config/server/colorSet.txt",%path @ "colorSet.txt");
	fileCopy("Add-Ons/System_GamemodeGenerator/thumb.jpg",%path @ "thumb.jpg");
	fileCopy("Add-Ons/System_GamemodeGenerator/preview.jpg",%path @ "preview.jpg");
	fileCopy(%this.scriptFile,%path @ "server.cs");
	%file = new FileObject();
	%file.openForWrite(%path @ "description.txt");
	%file.writeLine(%this.description);
	%file.close();
	%file.delete();	
	echo("Done at \"" @ %path @ ",\" deleting self");
	%this.delete();
}

function generateGamemode(%n,%d,%f,%m)
{

	new ScriptObject(GameModeGen)
	{
		name = %n;
		description = %d;
		scriptFile = %f;
		minigame = %m;
	};
}